<?php
/*##################################################
 *                            admin_download_maj.php
 *                            -------------------
 *   begin                : oct 21 2010
 *   by                   : SaTurNin
 *
 *
###################################################*/

require_once('../admin/admin_begin.php');
load_module_lang('download'); //Chargement de la langue du module.
define('TITLE', $LANG['administration'].'-maj');
require_once('../admin/admin_header.php');

$Cache->load('download');
include_once('admin_download_menu.php');

////////////////////////////////////////////
// Fonction perso de lecture d'un dossier //
////////////////////////////////////////////
//    Mis a jour pour un double trie     //
///////////////////////////////////////////

function GetFileList( $dirname="." ) {   
	if (! is_dir($dirname)) { return false; } // not a dir
	$files = array(); 
	$dir = @opendir( $dirname ) ;
	while( $file = readdir( $dir ) ) {
     	 if (stristr($file, '.php') != FALSE){
			if (preg_match('/download/',$file)){
				$files[] = $file; 
				}
			}
		}
	sort($files);
 	return $files;
	}

/////////////////////////////////////////////
           // fin fonction perso //
           ////////////////////////

// variable du bouton d'effacement qui sert de nom et de controle
$valid_del_cache_controle="!! Vider le cache !!";

/////////////////////////////////////////////
//detection de l'effacement pas cette page //
/////////////////////////////////////////////
$del_detect = retrieve(GET, 'confirm', '');
//if ( $del_detect === 'supp'){ redirect(HOST . SCRIPT); }

if (retrieve(POST,'valid',false))
{ 
$del__ok=retrieve(POST, 'valid', '', TSTRING);
// valid retrouv 

///////////////////////////////////////////
// lecture du dossier cache tpl et trie  //
///////////////////////////////////////////

$cache_path = '../cache/tpl/';
//$cache_path = '../cache/123/';
$cachelist = GetFileList($cache_path);
$nbr_tot = count($cachelist);
 if ($cachelist == false )
 {
	// pas de fichier, c'est pas possible mais bon ...
    	redirect(HOST . SCRIPT);
 }
else
 {
    $debut	 = 0;
    $cache_dl = GetFileList($cache_path) ;
    for($i=$debut; $i < $nbr_tot ; $i++)
      { 
	if( (file_exists($cache_path."".$cache_dl[$i])) && ($del__ok === $valid_del_cache_controle ))
	{
	    unlink($cache_path."".$cache_dl[$i]) ;
	}
    }
  }

 	redirect(HOST . SCRIPT.'?confirm=supp');


}else{ //on a apeler la page normalement. 

$Template->set_filenames(array(
	'admin_download_maj'=> 'download/admin_download_maj.tpl'
 ));

////////////////////////////////////////
// verification de la base de donne  //
////////////////////////////////////////

$maj_sql= "../download/db/french/download.mysql_2.1.sql" ;
$handle = fopen($maj_sql, "r");
$contents = fread($handle, filesize($maj_sql));
fclose($handle);

$maj_sql2 = "../download/db/french/download.mysql_2.2.sql" ;
$handle2 = fopen($maj_sql2, "r");
$contents2 = fread($handle2, filesize($maj_sql2));
fclose($handle2);


//echo "$contents" ;

$maj3=mysql_query("SELECT cb_external_script FROM " . PREFIX . "download"); 
if (!$maj3) { 
	$Template->assign_block_vars('sql', array( 'MAJ_ETAT'=> "Base de donne en cours de mise a jour.", ));
	$result = $Sql->query_inject(str_replace('phpboost_', PREFIX, $contents), __LINE__, __FILE__);
	$affected_rows = @$Sql->affected_rows($result, "");
	}else{
	$Template->assign_block_vars('sql', array( 'MAJ_ETAT'=> "Base de donne en version 2.1 => <font style='color:green;'>ok</font> <br/>", ));
	}

$maj4=mysql_query("SELECT view FROM " . PREFIX . "download"); 
if (!$maj4) { 
	$Template->assign_block_vars('sql', array( 'MAJ_ETAT'=> "Base de donne en cours de mise a jour.", ));
	$result = $Sql->query_inject(str_replace('phpboost_', PREFIX, $contents2), __LINE__, __FILE__);
	$affected_rows = @$Sql->affected_rows($result, "");
	}else{
	$Template->assign_block_vars('sql', array( 'MAJ_ETAT'=> "Base de donne en version 2.2 => <font style='color:green;'>ok</font> <br/>", ));
	}

///////////////////////////////////////////
// lecture du dossier cache tpl et trie  //
///////////////////////////////////////////

$cache_path = '../cache/tpl/';
//$cache_path = '../cache/123/';
$cachelist = GetFileList($cache_path);
$nbr_tot = count($cachelist);
 if ($cachelist == false )
 {
    $error_tpc_cache = true ;
 }
else
 {
    $debut	 = 0;
    $cache_dl = GetFileList($cache_path) ;
    for($i=$debut; $i < $nbr_tot ; $i++)
      { 
	if(file_exists($cache_path."".$cache_dl[$i]))
	{
	    $error_tpc_cache = false ;
	    $Template->assign_block_vars('liste_fichiers', array(
		'MAJ_CACHE' => $cache_dl[$i] ,
		'MAJ_CHMOD' => substr(sprintf('%o', fileperms($cache_path."".$cache_dl[$i])), -4) ,
		'MAJ_DATE' => date ("d/m/Y H:i:s ", filemtime($cache_path."".$cache_dl[$i])) ,
		'END_LINE' => "</tr>" ,
	    ));
	}
	    else
	{
 	   echo "Le fichier n'existe pas.<hr>";
	}
    }
  }




///////////////////
// Variable fixe //
///////////////////
if ( $del_detect === 'supp'){
$error_cache="<span class='notice'><br />Le cache est vide, vous venez de le vider.<br /></span>";
}else{
$error_cache="<span class='error'><br/>
Une erreur est survenu.<br/> Le dossier <b>cache/tpl</b> n'est pas accesible, n'est pas inscriptible ou ne contiens pas de fichiers du module.<br /> Une action semble requise par votre logiciel d'acces ftp</span>";
}

$Template->assign_vars(array(
		'L_MAJ' => "Mises a jour",
		'L_MAJ_ETAT'=> "Base de donne",
		'L_MAJ_TPL'=> "Cache TPL du module",
		'L_MAJ_TPL_EXPLAIN' => "Si le module de mise a jour ne met pas a jour le cache des tpl.<br />Cette fonction permet de vider le cache des tpl.<br /><br /><br />		<span class='success'>Le cache sera recrer au fur a mesure des besoins.</span>",

		'C_MAJ_ERROR'=> $error_tpc_cache,
		'L_MAJ_ERROR'=> $error_cache,
		'L_MAJ_NO_ERROR'=> "Liste des fichiers present dans le cache concernant le module download :<br />",
		
		'L_MAJ_CACHE' => "Nom de fichiers" ,
		'L_MAJ_CHMOD' => "CHMOD" ,
		'L_MAJ_DATE' => "Dernire modification" ,

		'L_UPDATE' => $valid_del_cache_controle,

	'L_DATE' => $LANG['date'],
));

////////////////////////////////////////////


$Template->pparse('admin_download_maj'); 
}
require_once('../admin/admin_footer.php');

?>
